procedure file_copy(file_src, file_dest: PathStr; OverWrite: Boolean);
var
        F_dest, F_src: file;
        NumRead, NumWritten: Word;
        Buf: Array[1..2048] Of Char;
begin
        file_done := False;
        {$I-}
        test_error(file_src);
        if file_exist_check(file_dest) and not OverWrite then
                Exit;

        Assign(F_dest, file_dest);
        Rewrite(F_dest, 1);
        test_error(file_dest);
        Assign(F_src, file_src);
        Reset(F_src, 1);
        test_error(file_src);
        {$I+}

        repeat
                BlockRead(F_src, Buf, SizeOf(Buf), NumRead);
                BlockWrite(F_dest, Buf, NumRead, NumWritten);
        until (NumRead = 0) or (NumWritten <> NumRead);
        Close(F_dest);
        Close(F_src);
        file_done := True;
end;

procedure file_merge(file_src, file_dest: PathStr);
var
        F_dest, F_src: file;
        NumRead, NumWritten: Word;
        Buf: Array[1..2048] of Char;
begin
        file_done := False;
        {$I-}
        Assign(F_src, file_src);
        Reset(F_src, 1);
        test_error(file_src);
        if file_exist_check(file_dest) then
        begin
                Assign(F_dest, file_dest);
                Reset(F_dest, 1);
                Seek(F_dest, FileSize(F_dest));
        end
        else
        begin
                Assign(F_dest, file_dest);
                Rewrite(F_dest, 1);
        end;
        test_error(file_dest);
        repeat
                BlockRead(F_src, Buf, SizeOf(Buf), NumRead);
                BlockWrite(F_dest, Buf, NumRead, NumWritten);
        until (NumRead = 0) or (NumWritten <> NumRead);
        Close(F_dest);
        Close(F_src);
        file_done := True;
        {$I+}
end;

procedure file_delete(file_dest: PathStr);
var
        F: file;
begin
        {$I-}
        Assign(F, file_dest);
        Erase(F);
        test_error(file_dest);
        {$I+}
        file_done := (IOResult = 0);
end;

procedure file_rename(file_src, file_dest: PathStr; OverWrite: Boolean);
var
        F: file;
begin
        file_done := False;
        {$I-}
        if not file_exist_check(file_src) then
        begin
                WriteLn(' ', file_src, '  ');
                Exit;
        end;
        if file_exist_check(file_dest) then
                if not OverWrite then Exit
                else
                begin
                        Assign(F, file_dest);
                        Erase(F);
                end;
                Assign(F, file_src);
                Rename(F, file_dest);
                test_error(file_dest);
                file_done := True;
        Close(F);
        {$I+}
end;
