program keyborad_last_song;

uses Dos, Crt;

var
        keyb_status_byte: Byte absolute $40:$17;
        num, caps, scroll: Boolean;
        old_num, old_caps, old_scroll: Boolean;
        loop: Byte;
        k: Integer;

const
        max = 51;

procedure get_leds_status(var n, c, s: Boolean);
begin
        s := True;
        if (keyb_status_byte and $10) = 0 then s := False;
        n := True;
        if (keyb_status_byte and $20) = 0 then n := False;
        c := True;
        if (keyb_status_byte and $40) = 0 then c := False;
end;

procedure set_leds_status(n, c, s: Boolean);
var
        reg: Registers;
begin
        if s then
                keyb_status_byte := keyb_status_byte or $10
        else
                keyb_status_byte := keyb_status_byte and not $10;
        if n then
                keyb_status_byte := keyb_status_byte or $20
        else
                keyb_status_byte := keyb_status_byte and not $20;
        if c then
                keyb_status_byte := keyb_status_byte or $40
        else
                keyb_status_byte := keyb_status_byte and not $40;
        reg.ax := $0200;
        Intr($16, reg);
end;

procedure keyb_song(tone: Integer);
const
        melody: array[0..max, 1..2] of Integer =(
                (0,      0), (1046, 200), (1046, 200), (1174, 400), (1046, 400),
                (1398, 400), (1318, 800), (1046, 200), (1046, 200), (1174, 400),
                (1046, 400), (1568, 400), (1398, 800), (1046, 200), (1046, 200),
                (2092, 400), (1760, 400), (1398, 400), (1318, 400), (1174, 800),
                (1864, 200), (1864, 200), (1760, 400), (1398, 400), (1568, 400),
                (1398, 800), (1046, 200), (1046, 200), (1174, 400), (1046, 400),
                (1398, 400), (1318, 800), (1046, 200), (1046, 200), (1174, 400),
                (1046, 400), (1568, 400), (1398, 800), (1046, 200), (1046, 200),
                (2092, 400), (1760, 400), (1398, 400), (1318, 400), (1174, 800),
                (1864, 200), (1864, 200), (1760, 400), (1398, 400), (1568, 400),
                (1398, 800), (0,     0));
begin
        Sound(melody[tone][1]);
        Delay(melody[tone][2]);
        NoSound;
end;

begin
        get_leds_status(old_num, old_caps, old_scroll);
        num:= False;
        caps := False;
        scroll := False;
        loop := 0;
        k := 0;
        WriteLn(' <Enter>  ⠭ ணࠬ');
        Randomize;
        repeat
                keyb_song(k);
                k := (k + 1) mod max;
                loop := Random(4);
                case loop of
                        0: scroll  := False;
                        1: num     := True;
                        2: begin
                                num    := False;
                                caps   := True;
                        end;
                        3: begin
                                caps   := False;
                                scroll := True;
                        end;
                end;
                set_leds_status(num, caps, scroll);
        until KeyPressed;
        set_leds_status(old_num, old_caps, old_scroll);
end.
