{$N+}
program Buffon;

uses Crt, Graph, graphs;

var
        crossed, thrown, drawlinecount, ltemp, rescalecount: LongInt;
        half_length: Double;
        nline, offset, step: Word;

procedure drawlines;
var
        row: Word;
begin
        SetLineStyle(0, 0, 1);
        SetColor(White);
        row := offset;
        nline := 0;
        while (row <= GetMaxY) do
        begin
                Line(0, row, GetMaxX, row);
                Inc(row, step);
                Inc(nline)
        end
end;

procedure setuplines;
begin
        ClearViewPort;
        offset := GetMaxY div 10;
        step := GetMaxY div 5;
        half_length := 0.5 * step;
        drawlines
end;

procedure beep;
begin
        Sound(500); Delay(2); NoSound;
end;

procedure thrown_needle;
var
        alpha, cos_theta, hypotenuse, sin_theta, x, y: Real;
        x_delta, y_delta, x_mid, y_mid: Integer;
begin
        alpha := Random - 0.5;
        x := 2.0 * (Random - 0.5);
        y := Random;
        if x = 0.0 then
        begin
                sin_theta := 1.0;
                cos_theta := 0.0
        end
        else
        begin
                hypotenuse := Sqrt(Sqr(x) + Sqr(y));
                sin_theta := y / hypotenuse;
                cos_theta := x / hypotenuse
        end;
        Inc(thrown);
        if Abs(alpha) <= 0.5 * sin_theta then
        begin
                Inc(crossed);
                beep;
        end;
        x_mid := Random(GetMaxX + 1);
        y_mid := offset + step * Random(1 + nline) + Round(alpha * step);
        x_delta := Round(half_length * cos_theta);
        y_delta := Round(half_length * sin_theta);
        SetColor(1 + Random(GetMaxColor));
        Line(x_mid - x_delta, y_mid - y_delta, x_mid + x_delta, y_mid + y_delta);
end;

procedure buffon_finished;
var
        pi_approximate: Real;
begin
        ClrScr;
        WriteLn;
        WriteLn(' '' 䮭'' - ᯥਬ⠫쭮 । ᫠ ');
        WriteLn;
        WriteLn('襭         ', thrown:9);
        Write('祭  ﬨ ', crossed:9);
        WriteLn;
        if crossed > 0 then
        begin
                pi_approximate := 2.0 * thrown / crossed;
                WriteLn('ਡ 祭 ᫠  ', pi_approximate:8:6);
        end;
        WriteLn;
end;

begin
        Randomize;
        thrown := 0;
        crossed := 0;
        rescalecount := 2000;
        drawlinecount := rescalecount div 5;
        open_graph;
        SetViewPort(0, 0, GetMaxX, GetMaxY, ClipOn);
        setuplines;
        repeat
                thrown_needle;
                Delay(200)
        until KeyPressed;
        close_graph;
        buffon_finished;
        WriteLn(' <Enter>');
        ReadLn; ReadLn;
end.
