program test_Graph_unit;

uses Crt, Dos, Graph;
var
        x, y, xx, yy: Integer;
        ch: Char;
        s: String;
        ptr: Pointer;
        size: Word;

procedure test_fill_styles;
procedure fill(x, y, style: Integer; color: Word; ss: String);

var
        prev_color: Word;

begin
        prev_color := GetColor;
        SetColor(White);
        OutTextXY(x, y - 15, ss);
        SetColor(prev_color);
        SetFillStyle(style, color);
        Rectangle(x, y, x + 90, y + 90);
        Bar(x + 1, y + 1, x + 89, y + 89);
end;{fill}

begin
        fill( 50, 70,  EmptyFill,       1, 'EmptyFill');
        fill(200, 70,  SolidFill,       2, 'SolidFill');
        fill(350, 70,  LineFill,        3, 'LineFill');
        fill(500, 70,  LtSlashFill,     4, 'LtSlashFill');
        fill( 50, 215, SlashFill,       5, 'SlashFill');
        fill(200, 215, BkSlashFill,     6, 'BkSlashFill');
        fill(350, 215, LtBkSlashFill,   7, 'LtBkSlashFill');
        fill(500, 215, HatchFill,       8, 'HatchFill');
        fill( 50, 345, XHatchFill,      9, 'XHatchFill');
        fill(200, 345, InterleaveFill, 10, 'InterleaveFill');
        fill(350, 345, WideDotFill,    11, 'WideDotFill');
        fill(500, 345, CloseDotFill,   12, 'CloseDotFill');
end;{test_fill_styles}

procedure fill_bar(x, y, xx, yy: Integer; color, raster: Byte);

const
        fil_pat :array[0..27] of FillPatternType =(
                ($ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff),
                (0, $fb, $fb, $fb, 0, $df, $df, $df),
                (0, $10, $28, $44, $28, $10, 0, 0),
                ($22, 0, $88, 0, $22, 0, $88, 0),
                ($cc, $33, $cc, $33, $cc, $33, $cc, $33),
                ($aa, $55, $aa, $55, $aa, $55, $aa, $55),
                ($94, $84, $48, $30, 0, $c1, $22, $14),
                ($aa, $aa, $aa, $aa, $aa, $aa, $aa, $aa),
                ($ff, 0, $ff, 0, $ff, 0, $ff, 0),
                ($ff, $1, $7d, $45, $5d, $41, $7f, 0),
                ($01, $82, $44, $28, $10, $20, $40, $80),
                (0, $3c, $42, $42, $42, $42, $3c, 0),
                (0, $7e, $7e, $7e, $7e, $7e, $7e, 0),
                ($81, $42, $24, $18, $18, $24, $42, $81),
                (0, $ec, $2a, $2a, $2a, $aa, $ec, 0),
                (0, $08, $18, $3f, $3f, $18, $08, 0),
                (0, 0, $7e, $42, $7e, $42, $7e, $42),
                ($80, $7f, $41, $41, $41, $41, $41, $7f),
                (0, $5d, $3e, $6b, $7f, $63, $36, $5d),
                (0, 0, $04, $08, $90, $a0, $c0, $f0),
                ($92, $24, $49, $92, $24, $49, $92, $24),
                ($b1, $22, $14, $14, $22, $91, $48, $24),
                ($18, $3c, $3c, $7e, $7e, $3c, $3c, $18),
                ($e7, $c3, $81, $18, $18, $81, $c3, $e7),
                ($2, $91, $68, $8, $10, $16, $89, $40),
                ($ff, $81, $81, $81, $81, $81, $81, $ff),
                (0, 0, $81, $81, $42, $24, $18, $18),
                ($c3, $42, $5a, $7e, $7e, $5a, $42, $c3));

begin
        if raster < 28 then
        begin
                SetFillPattern(fil_pat[raster], color);
                SetFillStyle(12, color);
                Bar(x, y, xx, yy);
        end;
end;{fill_bar}

procedure shadow_text(x, y: Integer; text: String; bg, vg, font, size: Byte);
begin
        SetTextStyle(font, 0, size);
        SetColor(bg);
        OutTextXY(x, y, text);
        SetColor(vg);
        OutTextXY(x + 1, y + 1, text);
        SetTextStyle(0, 0, 0);
end;

procedure info(s: String);
begin
        fill_bar(0, 0, 639, 49, 0, 0);
        shadow_text(20, 5, s, 14, 6, 2, 6);
end;

procedure test_get_put_image;

var
        ptr: Pointer;
        size: Word;

begin
        SetFillStyle(SolidFill, LightCyan);
        FillEllipse(100, 210, 20, 20);
        Circle(140, 210, 20);
        Rectangle(80, 190, 160, 230);
        size := ImageSize(80, 190, 160, 230);
        GetMem(ptr, size);
        GetImage(80, 190, 160, 230, ptr^);
        SetColor(White);
        SetFillStyle(SolidFill, Blue);
        Bar(280, 60, 400, 440);
        PutImage(300, 100, ptr^, CopyPut);
        PutImage(300, 160, ptr^, OrPut);
        PutImage(300, 220, ptr^, XorPut);
        PutImage(300, 280, ptr^, NotPut);
        PutImage(300, 340, ptr^, AndPut);
        OutTextXY(410, 120, 'CopyPut');
        OutTextXY(410, 180, 'OrPut');
        OutTextXY(410, 240, 'XorPut');
        OutTextXY(410, 300, 'NotPut');
        OutTextXY(410, 360, 'AndPut');
        FreeMem(ptr, size);
end;

procedure test_palette;

const
        col_num: array[0..15] of Word =
                (0, 1, 2, 3 ,4 ,5, 20, 7, 56, 57, 58, 59, 60, 61, 62, 63);

var
        k: Word;

begin
        Randomize;
        SetRGBPalette(col_num[LightRed], 63, 10, 10);
        SetFillStyle(SolidFill, LightRed);
        Bar(30, 50, 179, 450);
        SetRGBPalette(col_num[LightGreen], 9, 63, 9);
        SetFillStyle(SolidFill, LightGreen);
        Bar(180, 50, 329, 450);
        SetRGBPalette(col_num[LightBlue], 0, 0, 63);
        SetFillStyle(SolidFill, LightBlue);
        Bar(330, 50, 479, 450);
        SetRGBPalette(col_num[Brown], 40, 30, 0);
        SetFillStyle(SolidFill, Brown);
        Bar(480, 50, 629, 450);
        SetColor(White);
        OutTextXY(30, 50, 'LightRed');
        OutTextXY(180, 50, 'LightGreen');
        OutTextXY(330, 50, 'LightBlue');
        OutTextXY(480, 50, 'Brown');
        Delay(1000);
        repeat
                SetRGBPalette(col_num[LightRed], 63, Random(40), Random(40));
                Delay(100);
                SetRGBPalette(col_num[LightGreen], Random(40), 63, Random(40));
                Delay(100);
                SetRGBPalette(col_num[LightBlue], Random(40), Random(40), 63);
                Delay(100);
                SetRGBPalette(col_num[Brown], 30 + Random(20), 20 + Random(20), 0);
                Delay(100);
        until KeyPressed;
end;

procedure horizontal_reflection(mx, my, mxx, myy: Integer);
var
        pix1, pix2: Integer;
begin
        if (mx < 0) or (my < 0) or (mxx > GetMaxX) or
                (myy > GetMaxY) then Exit;
        for x := mx to mxx do

                for y := my to (my + myy) div 2 do

                begin
                        pix1 := GetPixel(x, y);
                        pix2 := GetPixel(x, my + myy - y);
                        PutPixel(x, my + myy - y, pix1);
                        PutPixel(x, y, pix2);
                end;
end;

procedure vertical_reflection(mx, my, mxx, myy: Integer);
var
        pix1, pix2: Integer;
begin
        if (mx < 0) or (my < 0) or (mxx > GetMaxX) or
                (myy > GetMaxY) then Exit;
        for y := my to myy do
                for x := mx to (mx + mxx) div 2 do
                begin
                        pix1 := GetPixel(x, y);
                        pix2 := GetPixel(mx + mxx - x, y);
                        PutPixel(mx + mxx - x, y, pix1);
                        PutPixel(x, y, pix2);
                end;
end;

begin
        x := VGA; y := VGAHi;
        InitGraph(x, y, '');
        ClearViewPort;
        SetColor(15);
        Rectangle(10, 50, 639, 450);
        info('Press <Enter>');
        ReadLn;

        info('Fill_Bar, Press <Enter>');
        fill_bar(11, 51, 638, 449, 3, 5);
        fill_bar(50, 100, 280, 180, 4, 4);
        fill_bar(450, 80, 580, 150, 0, 0);
        fill_bar(500, 350, 600, 430, 14, 20);
        ReadLn;

        info('Shadow_text, Press <Enter>');
        Shadow_text(100, 200, 'SHADOWTEXT...', 15, 7, 0, 2);
        Shadow_text(120, 230, 'HELLO!HELLO!!!', 13, 5, 0, 3);
        Shadow_text(140, 260, 'good bye, good bye...', 0, 11, 2, 6);
        ReadLn;

        info('Test_get_put_image, Press <Enter>');
        test_get_put_image;
        ReadLn;

        ClearViewPort;
        info('Test_fill_styles, Press <Enter>');
        Rectangle(10, 50, 639, 450);
        fill_bar(11, 51, 638, 449, 3, 5);
        test_fill_styles;
        ReadLn;

        info('Test_palette, Press <Enter>');
        test_palette;
        ReadLn;

        info('FloodFill, Circle, Ellipse, SetFillStyle, Press <Enter>');
        SetColor(15);
        Circle(100, 350, 50);
        SetFillStyle(1, 8);
        FloodFill(100, 350, 15);
        SetColor(13);
        FillEllipse(150, 350, 30, 60);
        SetFillStyle(2, 4);
        FloodFill(150, 350, 13);
        SetColor(10);
        SetFillStyle(4, 5);
        FillEllipse(250, 150, 90, 60);
        ReadLn;

        info('Vertical reflection, Press <Enter>');
        vertical_reflection(0, 50, 639, 450);
        ReadLn;

        info('Horizontal reflection, Press <Enter>');
        horizontal_reflection(0, 50, 639, 450);
        ReadLn;
end.
