program line;

uses Crt, Dos;

type
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;
        screentype = record
                buffer: screenbufferptr;
                ytable: array[0..199] of Word;
                width: Word;
                color: Word;
        end;

var
        screen: screentype;
        screen_y: array[0..199] of Word;
        i, j: Word;

procedure calcscreeny(width: Word);
var
        i: Integer;
begin
        for i := 0 to 199 do
                screen_y[i] := i * width;
end;

procedure init_graph;
var
        regs: Registers;
begin
        regs.ah := $00;
        regs.al := $13;
        Intr($10, regs);
        screen.buffer := Ptr($a000, 0);
        screen.width := 320;
        calcscreeny(320);
end;

procedure close_graph;
var
        regs: Registers;
begin
        regs.ah := $00;
        regs.al := $03;
        Intr($10, regs);
end;

procedure hline(x1, y, x2: Word; color: Byte);
var
        x, address: Word;
begin
        address := screen_y[y];
        for x := x1 to x2 do
                screen.buffer^[address+x] := color;
end;

procedure vline(x, y1, y2: Word; color: Byte);
var
        y, address: Word;
begin
        address := screen_y[y1] + x;
        for y := y1 to y2 do
        begin
                screen.buffer^[address] := color;
                address := address + screen.width;
        end;
end;

begin
        init_graph;
        for i := 0 to 199 do
                hline(0, i, 319, i mod 255);
        ReadLn;
        for i := 0 to 319 do
                vline(i, 0, 199, i mod 255);
        ReadLn;
        close_graph;
end.
