program segment_demo;

uses Crt, Dos;
type
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;
        screentype = record
                buffer: screenbufferptr;
                ytable: array[0..199] of Word;
                width: Word;
                color: Word;
        end;

var
        screen: screentype;
        screen_y: array[0..199] of Word;
        i, j: Word;

procedure calcscreeny(width: Word);
...

procedure init_graph;
...

procedure close_graph;
...

procedure hline(x1, y, x2: Word; color: Byte);
...

procedure vline(x, y1, y2: Word; color: Byte);
...

procedure set_pixel(x, y: Word; color: Byte);
...

procedure segment(x0, y0, x1, y1: Integer);
var
        dx, two_dx, dy, two_dy, abs_slope,
        Error, dError, eps, sum, t: Integer;

procedure bresenham_big_y;
begin
        if x1 < x0 then
        begin
                t := x0;
                x0 := x1;
                x1 := t;
                t := y0;
                y0 := y1;
                y1 := t;
        end;
        if y0 < y1 then
                eps := 1
        else
                eps := -1;
        Error := -dy;
        while Abs(y1 - y0) >= 2 do
        begin
                set_pixel(x0, y0, White);
                set_pixel(x1, y1, White);
                Error := Error + two_dx;
                if Error >= 0 then
                begin
                        Error := Error - two_dy;
                        Inc(x0); Dec(x1);
                end;
                y0 := y0 + eps;
                y1 := y1 - eps;
        end;
        if y0 = y1 then
                set_pixel(x0, y0, White)
        else
        begin
                set_pixel(x0, y0, White);
                set_pixel(x1, y1, White);
        end;
end;{bresenham_big_y}

procedure bresenham_big_x;
begin
        if y1 < y0 then
        begin
                t := x0;
                x0 := x1;
                x1 := t;
                t := y0;
                y0 := y1;
                y1 := t;
        end;
        if x0 < x1 then
                eps := 1
        else
                eps := -1;
        Error := -dx;
        while Abs(x1 - x0) >= 2 do
        begin
                set_pixel(x0, y0, White);
                set_pixel(x1, y1, White);
                Error := Error + two_dy;
                if Error >= 0 then
                begin
                        Error := Error - two_dx;
                        Inc(y0); Dec(y1);
                end;
                x0 := x0 + eps;
                x1 := x1 - eps;
        end;
        if x0 = x1 then
                set_pixel(x0, y0, White)
        else
        begin
                set_pixel(x0, y0, White);
                set_pixel(x1, y1, White);
        end;
end;{bresenham_big_x}

begin
        if x0 = x1 then
                vline(x0, y0, y1, White)
        else
                if y0 = y1 then
                        hline(x0, x1, y0, White)
                else
                begin
                        dx := Abs(x1 - x0);
                        dy := Abs(y1 - y0);
                        two_dx := 2 * dx;
                        two_dy := 2 * dy;
                                        if dx <= dy then
                                                bresenham_big_y
                                        else
                                                bresenham_big_x;
                end;
end;{segment}

begin
        init_graph;
        segment(10, 180, 300, 30);
        ReadLn;
        close_graph;
end.
