program lineclipping;

uses Crt, Dos;

type
        recttype = record
                x_min, y_min, x_max, y_max: Integer;
        end;
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;
        screentype = record
                buffer: screenbufferptr;
                dbuffer: Boolean;
                ytable: array[0..199] of Word;
                width: Word;
                clip: recttype;
        end;

var
        x1, y1, x2, y2, tmp: Integer;
        screen: screentype;
        screen_y: array[0..199] of Word;
        i, j: Word;

procedure calcscreeny(width: Word);
...

procedure init_graph;
...

procedure close_graph;
...

procedure setclipboundary(x1, y1, x2, y2: Integer);
begin
        screen.clip.x_min := x1;
        screen.clip.y_min := y1;
        screen.clip.x_max := x2;
        screen.clip.y_max := y2;
end;

procedure hline(x1, y, x2: Word; color: Byte);
...

procedure vline(x, y1, y2: Word; color: Byte);
...

procedure set_pixel(x, y: Word; color: Byte);
....

procedure bresenhamline(x1, y1, x2, y2: Word; color: Byte);
...

procedure linec(x1, y1, x2, y2: Integer; color: Byte);

const
        codebottom = 1;
        codetop = 2;
        codeleft = 4;
        coderight = 8;

function compute_code(x, y: Integer): Byte;
var
        code: Byte;
begin
        code := 0;
        if y > screen.clip.y_max then
                code := codebottom
        else
                if y < screen.clip.y_min then
                        code := codetop;
        if x > screen.clip.x_max then
                code := code + coderight
        else
                if x < screen.clip.x_min then
                        code := code + codeleft;
        compute_code := code;
end;{compute_code}

var
        outcode0, outcode1, outcodeout: Byte;
        x, y: Integer;
begin
        outcode0 := compute_code(x1, y1);
        outcode1 := compute_code(x2, y2);
        while (outcode0 <> 0) or (outcode1 <> 0) do
        begin
                if (outcode0 and outcode1) <> 0 then
                        Exit
                else
                begin
                        if outcode0 > 0 then
                                outcodeout := outcode0
                        else
                                outcodeout := outcode1;
                        if (outcodeout and codebottom) = codebottom then
                        begin
                                y := screen.clip.y_max;
                                x := x1 + LongInt(x2 - x1) * LongInt(y - y1) div (y2 - y1);
                        end
                        else
                                if (outcodeout and codetop) = codetop then
                                begin
                                        y := screen.clip.y_min;
                                        x := x1 + LongInt(x2 - x1) * LongInt(y - y1) div (y2 - y1);
                                end
                                else
                                        if (outcodeout and coderight) = coderight then
                                        begin
                                                x := screen.clip.x_max;
                                                y := y1 + LongInt(y2 - y1) *
                                                                        LongInt(x - x1) div (x2 - x1);
                                        end
                                        else
                                                if (outcodeout and codeleft) = codeleft then
                                                begin
                                                        x := screen.clip.x_min;
                                                        y := y1 + LongInt(y2 - y1) *
                                                                LongInt(x - x1) div (x2 - x1);
                                                end;
                        if (outcodeout = outcode0) then
                        begin
                                x1 := x; y1 := y;
                                outcode0 := compute_code(x1, y1);
                        end
                        else
                        begin
                                x2 := x; y2 := y;
                                outcode1 := compute_code(x2, y2);
                        end;
                end;
        end;
        Line(x1, y1, x2, y2, color);
end;{linec}

begin
        Randomize;
        init_graph;
        SetClipBoundary(30, 30, 190, 150);
        vline(30, 30, 150, 7);
        vline(190, 30, 150, 7);
        hline(30, 30, 190, 7);
        hline(30, 150, 190, 7);
        repeat
                x1 := Random(320);
                y1 := Random(200);
                x2 := Random(320);
                y2 := Random(200);
                if x1 > x2 then
                begin
                        tmp := x2; x2 := x1; x1 := tmp
                end;
                if y1 > y2 then
                begin
                        tmp := y2; y2 := y1; y1 := tmp
                end;
                linec(x1, y1, x2, y2, 7);
        until ReadKey = #27;
        close_graph;
end.
