program demo_VGA;

uses Crt, Graph, Dos;

var
        GraphDriver, GraphMode: Integer;
        k: Word;
        x, y, attr, x1, y1, top, bottom, mode, cols, page: Byte;
        ss, tt: String[80];
        reg: Registers;

procedure set_cursor_position(page, x, y: Byte);
begin
        with reg do
        begin
                AH := $02;
                BH := page;
                DH := y;
                DL := x;
        end;
        Intr($10, reg);
end;

procedure get_cursor(page: Byte; var x, y: Byte);
begin
        reg.AH := $03;
        reg.BH := page;
        Intr($10, reg);
        with reg do
        begin
                y := DH;
                x := DL;
        end;
end;

procedure write_chars(page, x, y: Byte; ch0: Char; attr: Byte; multiplicity: Word);
begin
        set_cursor_position(page, x, y);
        with reg do
        begin
                AH := $09;
                AL := Ord(ch0);
                BH := page;
                BL := attr;
                CX := multiplicity;
        end;
        Intr($10, reg);
end;

procedure write_string(page, x, y: Byte; ss: String; attr: Byte);
var
        j: Word;
begin
        for j := 1 to Length(ss) do
        begin
                write_chars(page, x, y, ss[j], attr, 1);
                Inc(x);
        end;
end;

begin
        GraphDriver := Detect;
        InitGraph(GraphDriver, GraphMode, ' ');
        SetBkColor(DarkGray);
        SetColor(LightBlue);
        ss := 'Graphics mode';
        FillEllipse(320, 240, 20, 20);
        x := 0;
        y := 0;
        write_string(0, x, y, ss, white);
        set_cursor_position(0, 0, 5);
        y := 5;
        attr := 16 * Brown + LightCyan;
        for k := 0 to 15 do
        begin
                Str(k:3, ss);
                x := 3 * k;
                write_string(0, x, y, ss, attr);
        end;
        for k := 0 to 15 do
                write_chars(0, 3 * k + 2, 6, Chr(k), attr, 1);
        set_cursor_position(0, 0, 8);
        y := 8;
        for k := 0 to 15 do
        begin
                Str((16 + k):3, ss);
                x := 3 * k;
                write_string(0, x, y, ss, attr);
        end;
        for k := 0 to 15 do
                write_chars(0, 3 * k + 2, 9, Chr(16 + k), attr, 1);
        ss := '0123456';
        x := 0;
        y := 20;
        write_string(0, x, y, ss, 11);
        get_cursor(0, x, y);
        Str(x, ss);
        Str(y, tt);
        Inc(y);
        ss := 'At end of ''0123456'', (x, y) = (' + ss + ', ' + tt + ')';
        write_string(0, x, y, ss, White);
        ss := 'Press <Enter>: ';
        x := 0;
        y := 25;
        attr := 16 * DarkGray + Yellow;
        write_string(0, x, y, ss, attr);
        get_cursor(0, x, y);
        repeat
                write_chars(0, x, y, '-', Yellow, 1);
                Delay(100);
                write_chars(0, x, y, '-', LightBlue, 1);
                Delay(100);
        until KeyPressed;
        ReadLn;
        CloseGraph;
end.
