program save_VGA;

uses
        Dos, Crt, Graph;

const
        pixels = 38400;
        file_name = 'picture';

type
        plane = array[1..pixels] of Byte;

var
        storage: File;
        result: Word;
        graph_driver, graph_mode: Integer;

procedure fill_screen;
const
        dx = 640 div 4;
        dy = 480 div 4;
var
        i, j, x, y: Integer;
        color: Word;
begin
        color := 0; y := 0;
        for i := 0 to 3 do
        begin
                x := 0;
                for j := 0 to 3 do
                begin
                        SetFillStyle(SolidFill, color);
                        Bar(x, y, x + dx, y + dy);
                        Inc(x, dx); Inc(color);
                end;
                Inc(y, dy);
        end;
end;

procedure copy_screen;
var
        i: Byte;
begin
        Assign(storage, file_name);
        Rewrite(storage, 1);
        port[$3CE] := 4;
        for i := 3 downto 0 do
        begin
                port[$3CF] := i;
                BlockWrite(storage, Mem[segA000:$0000], pixels, result);
                if result <> pixels then
                begin
                        WriteLn('訡 : i = ', i);
                        ReadLn;
                        Halt;
                end;
        end;
        Close(storage);
end;

procedure restore_screen;
var
        i, j, k: Byte;
begin
        Assign(storage, file_name);
        Reset(storage, 1);
        port[$3C4] := 2;
        j := 8;
        repeat
                port[$3C5] := j;
                BlockRead(storage, Mem[segA000:$0000], pixels, result);
                if result <> pixels then Break;
                j := j shr 1;
        until j = 0;
        Close(storage);
        port[$3C5] := $0F;
end;

begin
        ClrScr;
        graph_driver := Detect;
        InitGraph(graph_driver, graph_mode, ' ');
        if GraphResult <> 0 then Halt;
        fill_screen;
        copy_screen;
        ReadLn;
        CloseGraph;
        WriteLn('⮢ ०,  <Enter>:');
        ReadLn;
        InitGraph(graph_driver, graph_mode, ' ');
        restore_screen;
        OutText('Graph screen');
        ReadLn;
        CloseGraph;
end.
