program cubes;

uses
        Crt, Graph, graphs;

type
        point_position = record
                                                        x, y, z: Real;
                                                end;
        plane_position = array[1..5] of point_position;
        cube_coordinates = array[1..6] of plane_position;

var
        c: Char;
        pcos, ncos, psin, nsin: Real;

const
        cube: cube_coordinates = ((( x : -25; y : -25; z : +25),
                                                                (x : +25; y : -25; z : +25),
                                                                (x : +25; y : +25; z : +25),
                                                                (x : -25; y : +25; z : +25),
                                                                (x :   0; y :   0; z : +25)),
                                                                ((x : -25; y : -25; z : -25),
                                                                (x : +25; y : -25; z : -25),
                                                                (x : +25; y : -25; z : +25),
                                                                (x : -25; y : -25; z : +25),
                                                                (x : 0; y : -25; z : 0)),

                                                                ((x : -25; y : +25; z : +25),
                                                                (x : +25; y : +25; z : +25),
                                                                (x : +25; y : +25; z : -25),
                                                                (x : -25; y : +25; z : -25),
                                                                (x : 0; y : +25; z : 0)),

                                                                ((x : -25; y : -25; z : -25),
                                                                (x : -25; y : -25; z : +25),
                                                                (x : -25; y : +25; z : +25),
                                                                (x : -25; y : +25; z : -25),
                                                                (x : -25; y : 0; z : 0)),

                                                                ((x : +25; y : -25; z : +25),
                                                                (x : +25; y : -25; z : -25),
                                                                (x : +25; y : +25; z : -25),
                                                                (x : +25; y : +25; z : +25),
                                                                (x : +25; y : 0; z : 0)),

                                                                ((x : -25; y : +25; z : -25),
                                                                (x : +25; y : +25; z : -25),
                                                                (x : +25; y : -25; z : -25),
                                                                (x : -25; y : -25; z : -25),
                                                                (x : 0; y : 0; z : -25)));

procedure rotx;
var
        y1, z1: Real;
        i, j: Integer;
begin
        for i := 1 to 6 do
                for j := 1 to 5 do
                begin
                        y1 := pcos * cube[i, j].y - psin * cube[i, j].z;
                        z1 := psin * cube[i, j].y + pcos * cube[i, j].z;
                        cube[i, j].y := y1;
                        cube[i, j].z := z1;
                end
end;

procedure roty;
var
        x1, z1: Real;
        i, j: Integer;
begin
        for i := 1 to 6 do
                for j := 1 to 5 do
                begin
                        x1 := pcos * cube[i, j].x - psin * cube[i, j].z;
                        z1 := psin * cube[i, j].x + pcos * cube[i, j].z;
                        cube[i, j].x := x1;
                        cube[i, j].z := z1;
                end
end;

procedure rotz;
var
        y1, x1: Real;
        i, j: Integer;
begin
        for i := 1 to 6 do
                for j := 1 to 5 do
                begin
                        y1 := pcos * cube[i, j].y - psin * cube[i, j].x;
                        x1 := psin * cube[i, j].y + pcos * cube[i, j].x;
                        cube[i, j].y := y1;
                        cube[i, j].x := x1;
                end
end;

procedure display_cube(col: Byte);
var
        i, j, a: Integer;
        c: Byte;
        vertex:array[1..4] of PointType;
begin
        for i := 1 to 6 do
                if cube[i, 5].z > 0 then
                begin
                        for a := 1 to 3 do
                        begin
                                if col > 0 then
                                        c := white
                                else
                                        c := 0;
                                SetColor(c);
                                for j := 1 to 4 do
                                begin
                                        vertex[j].x := a * 150 + Round(cube[i ,j].x);
                                        vertex[j].y := GetMaxY div 2 + Round(cube[i, j].y);
                                end;
                                Line(vertex[1].x, vertex[1].y, vertex[2].x, vertex[2].y);
                                Line(vertex[2].x, vertex[2].y, vertex[3].x, vertex[3].y);
                                Line(vertex[3].x, vertex[3].y, vertex[4].x, vertex[4].y);
                                Line(vertex[4].x, vertex[4].y, vertex[1].x, vertex[1].y);
                end;
        end;
end;

procedure init;
begin
        pcos := Cos(6 * 2 * pi / 360);
        ncos := Cos(-6 * 2 * pi / 360);
        psin := Sin(6 * 2 * pi / 360);
        nsin := Sin(-6 * 2 * pi / 360);
end;

begin
        open_graph; init;
        repeat
                display_cube(1);
                repeat
                        c := ReadKey;
                        until(UpCase(c) in ['X', 'Y', 'Z', 'J', 'K', 'L', 'U', 'I'])
                                or (c = #27);
                        display_cube(0);
                        case UpCase(c) of
                                'Z': rotz;
                                'X': rotx;
                                'Y': roty;
                                'J': begin
                                        rotx;
                                        roty;
                                end;
                                'L': begin
                                        rotx;
                                        rotz;
                                end;
                                'K': begin
                                        roty;
                                        rotz;
                                end;
                                'I': begin
                                        rotx;
                                        roty;
                                        rotz;
                                end;
                        end;
        until c = #27;
        repeat
                display_cube(1);
                Delay(100);
                display_cube(0);
                rotx;
                roty;
                rotz;
        until KeyPressed;
        close_graph;
end.
