program eight_queens;

uses
        Crt;

const
        max = 7;
        m = 2 * max;

type
        vector = array[0..max] of Word;

var
        solution: vector;
        Q_row: array[0..max] of Boolean;
        Q_up_diag: array[-max..max] of Boolean;
        Q_down_diag: array[0..m] of Boolean;
        done: Boolean;
        row, col, diag: Integer;
        total, count: Word;
        out_file: file of vector;

procedure remove_queen;
begin
        Q_row[row] := False;
        Q_down_diag[col + row] := False;
        Q_up_diag[col - row] := False;
end;

procedure backtrack;
begin
        if KeyPressed then
                Halt;
        Dec(col);
        row := solution[col];
        while (row = max) and (col > 0) do
        begin
                remove_queen;
                Dec(col);
                row := solution[col];
        end;
        if row < max then
        begin
                remove_queen;
                Inc(row);
        end
        else
                done := True;
end;

procedure print;
begin
        Write('襭 ', count:2, ':  ');
        Write('[');
        for col := 0 to max do
                Write(solution[col]:3);
        WriteLn(']':3);
        Write(out_file, solution);
end;

begin
        Assign(out_file, '8queens.dat');
        Rewrite(out_file);
        ClrScr;
        total := 0;
        count := 0;
        WriteLn(' 襭   ', max + 1, ' ');
        WriteLn;

        done := False;
        for row := 0 to max do
                Q_row[row] := False;
        for diag := -max to max do
                Q_up_diag[diag] := False;
        for diag := 0 to m do
                Q_down_diag[diag] := False;
        row := 0;
        col := 0;

        repeat
                if Q_row[row] or Q_down_diag[col + row] or
                        Q_up_diag[col - row] then
                                if row = max then
                                        backtrack
                                else
                                        Inc(row)
                else
                begin
                        solution[col] := row;
                        Q_row[row] := True;
                        Q_down_diag[col + row] := True;
                        Q_up_diag[col - row] := True;
                        if col = max then
                        begin
                                Inc(total);
                                Inc(count);
                                print;
                                remove_queen;
                                backtrack;
                        end
                        else
                        begin
                                Inc(col);
                                row := 0;
                        end;
                end;
        until done;

        WriteLn;
        WriteLn('᫮ 襭: ', total);
        WriteLn;
        Write(' <Enter>: ');
        ReadLn;
        Close(out_file);
end.
