{$r+}
unit matrices;

interface

uses
        Crt;

const
        max = 3;

type
        str10 = String[10];
        str30 = String[30];
        matrix = array[1..max, 1..max] of Pointer;
        rational = record
                num, den: LongInt;
        end;
        rational_ptr = ^rational;
        rational_matrix = array[1..max, 1..max] of rational;
        real_ptr = ^Real;
        real_matrix = array[1..max, 1..max] of Real;
        complex = record
                re, im: Real;
        end;
        complex_ptr = ^complex;
        complex_matrix = array[1..max, 1..max] of complex;

        matrix_obj = object
                M: matrix;
                constructor init;
                procedure set_to_zero(var p: Pointer); virtual;
                procedure scalar_sum(const p, q: Pointer; var r: Pointer); virtual;
                procedure scalar_product(const p, q: Pointer; var r: Pointer); virtual;
                procedure matrix_sum(const A, B: matrix);
                procedure matrix_product(const A, B: matrix);
                procedure convert_to_string(p: Pointer; var tt: str30); virtual;
                procedure print(name: str10);
                destructor done;
        end;

        real_matrix_obj = object(matrix_obj)
                constructor init(M0: real_matrix);
                procedure set_to_zero(var p: Pointer); virtual;
                procedure scalar_sum(const p, q: Pointer; var r: Pointer); virtual;
                procedure scalar_product(const p, q: Pointer; var r: Pointer); virtual;
                procedure convert_to_string(p: Pointer; var tt: str30); virtual;
                destructor done;
        end;

        rational_matrix_obj = object(matrix_obj)
                constructor init(M0: rational_matrix);
                procedure set_to_zero(var p: Pointer); virtual;
                procedure scalar_sum(const p, q: Pointer; var r: Pointer); virtual;
                procedure scalar_product(const p, q: Pointer; var r: Pointer); virtual;
                procedure convert_to_string(p: Pointer; var tt: str30); virtual;
                destructor done;
        end;

        complex_matrix_obj = object(matrix_obj)
                constructor init(M0: complex_matrix);
                procedure set_to_zero(var p: Pointer); virtual;
                procedure scalar_sum(const p, q: Pointer; var r: Pointer); virtual;
                procedure scalar_product(const p, q: Pointer; var r: Pointer); virtual;
                procedure convert_to_string(p: Pointer; var tt: str30); virtual;
                destructor done;
        end;
