implementation

procedure quotient(const F, G: power_series; var H: power_series);

var
        r, k: Word;
        sum: Real;

begin
        if (F[0] <> 1.0) or (G[0] <> 1.0) then
                Halt;
        H := One;
        for r := 1 to max_deg do
        begin
                sum := F[r];
                for k := 0 to r - 1 do
                        sum := sum - H[k] * G[r - k];
                H[r] := sum;
        end;
end;

procedure composition(const F, G: power_series; var H: power_series);

var
        j, k: Word;
        P: power_series;

begin
        if (F[0] <> 0.0) or (G[0] <> 0.0) or
        (F[1] <> 1.0) or (G[1] <> 1.0) then
                        Halt;
        for k := 1 to max_deg
                do H[k] := F[1] * G[k];
        for k := 2 to max_deg do
                if F[k] <> 0.0 then
                begin
                        nth_power(G, k, P);
                        for j := k to max_deg do
                                H[j] := H[j] + F[k] * P[j];
                end;
end;
