procedure nth_power(const F: power_series; n: Word; var G: power_series);

var
        deg_F, deg_G, j, k, r: Integer;
        p, sum, t: Real;

begin
        if F[0] <> 0.0 then
                Exit;
        G := Zero;
        deg_F := 0;
        repeat
                Inc(deg_F)
        until (Abs(F[deg_F]) >= eta) or (deg_F = max_deg);
        deg_G := deg_F * n;
        if (F[deg_F] = 0.0) or (deg_G > max_deg) then
                Exit;
        p := 1.0;
        t := F[deg_F];
        for j := 1 to n do
                p := p * t;
        G[deg_G] := p;
        for r := deg_G + 1 to max_deg do
        begin
                sum := 0.0;
                k := r;
                for j := deg_F + 1 to r + deg_F - deg_G do
                begin
                        Dec(k);
                        sum := sum + (k - n * j) * F[j] * G[k];
                end;
                G[r] := - sum / ((r - n * deg_F) * F[deg_F]);
        end;
end;

begin
        for k := 0 to max_deg do
                Zero[k] := 0.0;
        One := Zero;
        One[0] := 1.0;
end.
