implementation

uses
        Crt;

const
        tol = 1.0e-30;

procedure get_matrix(var A: symmetric_matrix);
...

procedure print_matrix(var A: symmetric_matrix; name: str4);
...

procedure iterate(const A: symmetric_matrix; var v: vector;
                var r: Real; var fail: Boolean);

var
        x: Real;
        count, j, k: Word;
        w: vector;
        test: Boolean;

function norm_squared(const v: vector): Real;

var
        x: Real;
        j: Integer;

begin
        x := 0.0;
        for j := 1 to dim do
                x := x + Sqr(v[j]);
        norm_squared := x;
end;{norm_squared}

function distance_squared(const v, w: vector): Real;

var
        x: Real;
        j: Integer;

begin
        x := 0.0;
        for j := 1 to dim do
                x := x + Sqr(v[j] - w[j]);
        distance_squared := x;
end;{distance_squared}

begin{iterate}
        count := 0;
        fail := False;
        test := False;
        repeat
                Inc(count);
                w := v;
                for j := 1 to dim do
                begin
                        x := 0.0;
                        for k := 1 to dim do
                                x := x + A[k, j] * w[k];
                        v[j] := x;
                end;
                x := norm_squared(v);
                if x < tol then
                        fail := True
                else
                begin
                        r := 0.0;
                        for j := 1 to dim do
                                r := r + v[j] * w[j];
                        x := 1.0 / Sqrt(x);
                        if r < 0.0 then
                                x := -x;
                        for j := 1 to dim do
                                v[j] := x * v[j];
                        test := (distance_squared(v, w) < tol);
                end;
        until fail or test or (count = 200);
        fail := not test;
end;{iterate}
