unit integral;

interface

const
        max_dim = 10;
        max_deg = 96;

type
        real_fun = function(x: Real): Real;
        real_fun2 = function(x, y: Real): Real;
        real_vec = array[1..max_dim + 1] of Real;
        index = array[1..max_dim + 1] of Word;
        vec_fun = function(j: Word; x: Real_vec): Real;

var
        no_evaluations, highest_level: Word;

function simpson(F: real_fun; x0, x1: Real; div_no: Word): Real;
function double_simpson(F: real_fun2; x0, x1, y0, y1: Real;
                x_div, y_div: Word): Real;
function adaptive_simpson(F: real_fun; x0, x1, eps, eta: Real): Real;
function romberg(f: real_fun; x0, x1, eps, eta: Real;
                min, max: Word): Real;
function gauss3(F: real_fun; x0, x1: Real; n: Word): Real;
procedure compute_gauss_coeffs(deg: Word);
function gauss(F: real_fun; x0, x1: Real; deg: Word): Real;
