function double_simpson(F: real_fun2; x0, x1, y0, y1: Real;
                x_div, y_div: Word): Real;

var
        dx, dy, x, sum: Real;
        i: Word;

function simple_simpson(x: Real): Real;

var
        y, sum: Real;
        j, v: Word;

begin
        sum := F(x, y0) + F(x, y1);
        y := y0;
        for j := 1 to 2 * y_div - 1 do
        begin
                y := y + dy;
                if Odd(j) then
                        sum := sum + 4.0 * F(x, y)
                else
                        sum := sum + 2.0 * F(x, y);
        end;
        simple_simpson := sum;
end;{simple_simpson}

begin{double_simpson}
        dx := (x1 - x0) / (2.0 * x_div);
        dy := (y1 - y0) / (2.0 * y_div);
        x := x0;
        sum := simple_simpson(x0) + simple_simpson(x1);
        for i := 1 to 2 * x_div - 1 do
        begin
                x := x + dx;
                if Odd(i) then
                        sum := sum + 4.0 * simple_simpson(x)
                else
                        sum := sum + 2.0 * simple_simpson(x);
        end;
        double_simpson := dx * dy * sum / 9.0;
end;{double_simpson}
