function gauss3(F: real_fun; x0, x1: Real; n: Word): Real;

var
        t, sum, x, z, dx: Real;
        i, k: Word;
        gzero, gweight: array[1..3] of Real;

procedure initialize_constants;

var
        s, t: Real;
        j: Word;

begin
        gzero[1] := -Sqrt(0.6);
        gzero[2] := 0.0;
        gzero[3] := Sqrt(0.6);
        gweight[1] := 5.0 / 9.0;
        gweight[2] := 8.0 / 9.0;
        gweight[3] := 5.0 / 9.0;
        for j := 1 to 3 do
        begin
                gzero[j] := 0.5 * (1.0 + gzero[j]);
                gweight[j] := 0.5 * gweight[j];
        end;
end;{initialize_constants}

begin{gauss3}
        initialize_constants;
        dx := (x1 - x0) / n;
        x := x0;
        sum := 0.0;
        for i := 0 to n - 1 do
        begin
                t := 0.0;
                for k := 1 to 3 do
                begin
                        z := x + dx * gzero[k];
                        t := t + gweight[k] * F(z)
                end;
                sum := sum + dx * t;
                x := x + dx;
        end;
        gauss3 := sum;
end;{gauss3}
